﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.UI;

namespace _1075245_RadChartViewZoomInRange
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ChartPanZoomController panZoomController = new ChartPanZoomController();
            panZoomController.PanZoomMode = ChartPanZoomMode.Both;
            radChartView1.Controllers.Add(panZoomController);

            LineSeries lineSeries = new LineSeries();
            Random r = new Random();
            for (int i = 0; i < 25; i++)
            {
                lineSeries.DataPoints.Add(new CategoricalDataPoint(r.Next(100), "Cat " + i));
            }

            this.radChartView1.Series.Add(lineSeries);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            IChartView view = ((IChartView)this.radChartView1.View);
            double panX = view.PlotOriginX;
            double panY = view.PlotOriginY;
            double zoomX = view.ZoomWidth;
            double zoomY = view.ZoomHeight;

            foreach (var series in this.radChartView1.Series)
            {
                foreach (var dp in series.DataPoints)
                {
                    CategoricalDataPoint cdp = (CategoricalDataPoint)dp;
                    if (CheckIfDataPointIsVisible(view, cdp))
                    {
                        Console.WriteLine(cdp.Category + " " + cdp.Value);
                    }
                }
            }
        }

        private bool CheckIfDataPointIsVisible(IChartView view, CategoricalDataPoint cdp)
        {
            bool inXRange = cdp.LayoutSlot.X >= -view.PlotOriginX && cdp.LayoutSlot.X <= -view.PlotOriginX + view.ViewportWidth;
            bool inYRange = cdp.LayoutSlot.Y >= -view.PlotOriginY && cdp.LayoutSlot.Y <= -view.PlotOriginY + view.ViewportHeight;

            return inXRange && inYRange;
        }
    }
}
